#define BLOCKCOUNT 27

typedef enum _tag {
    T_B, T_EM, T_I, T_PL, T_S, T_TT, T_U,
    T_0, T_1, T_2, T_3, T_4, T_5, T_6, T_7, T_8, T_9,
    T_r, T_g, T_b, T_c, T_m, T_y, T_k, T_w, T_NONE=-1
} TAG;

typedef struct _tagholder {
    signed char open[32];
    int openlen;
    signed char close[32];
    int closelen;
} TAGHOLDER;

extern int o_length;

extern ENTITY *o_ents;
extern TAGHOLDER *o_tags;

extern signed char *o_bold, *o_emph, *o_italic, *o_strong, *o_tt;
extern signed char *o_u1, *o_u2, *o_u3;
extern signed char *o_color[8], *o_size[10];
extern signed char *o_plain;

extern signed char *o_block[BLOCKCOUNT];
extern signed char *o_temp[BLOCKCOUNT];

extern TAG o_taglist[];

char *opt(ENTITY *);
