#include <stdio.h>

#include "parser.h"
#include "opt.h"
#include "findrun.h"

void placetags(int start, int end)
{
    int runstart, runend;
    TAG t;

    /*fprintf(stderr, "placetags(%d, %d)\n", start, end);

    {
        int i, j;
        for (j = 0; j < 5; j ++) {
            for (i = 0; i < o_length; i ++)
                switch (o_block[j][i]) {
                case 1: fprintf(stderr, "="); break;
                case -1: fprintf(stderr, "-"); break;
                default: fprintf(stderr, " "); break;
                }
            fprintf(stderr, "\n");
            for (i = 0; i < o_length; i ++)
                fprintf(stderr, o_temp[j][i]?"#":"_");
            fprintf(stderr, "\n");
        } 
    }*/

    t = findrun(start, end, &runstart, &runend);
    if (t == T_NONE) return;
    /*fprintf(stderr, "run: start=%d end=%d tag=%d\n", runstart, runend, t);*/

    o_tags[runstart].open[o_tags[runstart].openlen] = (signed char)t;
    o_tags[runstart].openlen ++;
    o_tags[runend].close[o_tags[runend].closelen] = (signed char)t;
    o_tags[runend].closelen ++;

    updatecuts(runstart, 0, o_length);
    updatecuts(runend, 0, o_length);

    placetags(start, runstart);
    placetags(runstart, runend);
    placetags(runend, end);
}
