#include <stdio.h>

#include "parser.h"
#include "opt.h"
#include "plain.h"

static int isplain(int p)
{
    /*fprintf(stderr, "isplain(%d)\n", p);*/
    if (o_u1[p] != 1 && o_u2[p] != 1 && o_u3[p] != 1 &&
        o_bold[p] != 1 && o_emph[p] != 1 && o_italic[p] != 1 &&
        o_strong[p] != 1 && o_tt[p] != 1)
        return 1;
    else return 0;
}

static int countattr(int p)
{
    int count = 0;
    /*fprintf(stderr, "countattr(%d)\n", p);*/
    if (o_u1[p] == 1) count ++;
    if (o_u2[p] == 1) count ++;
    if (o_u3[p] == 1) count ++;
    if (o_bold[p] == 1) count ++;
    if (o_emph[p] == 1) count ++;
    if (o_italic[p] == 1) count ++;
    if (o_strong[p] == 1) count ++;
    if (o_tt[p] == 1) count ++;
    return count;
}

void insertplain()
{
    int i, j, k;
    for (i = 1; i < o_length-1; i ++) {
        if (isplain(i) && countattr(i-1) > 1) {
            j = i;
            while (isplain(j) && j < o_length-1) j ++;
            if (attrcmp(&o_ents[i-1], &o_ents[j])) {
                for (k = i; k < j; k ++) {
                    o_plain[k] = 1;
                    o_u1[k] = -1;
                    o_u2[k] = -1;
                    o_u3[k] = -1;
                    o_bold[k] = -1;
                    o_emph[k] = -1;
                    o_italic[k] = -1;
                    o_strong[k] = -1;
                    o_tt[k] = -1;
                }
            }
            i = j;
        }
    }
}
