/*
    test.c - very primitive testing program
*/

#include <stdio.h>
#include "reader.h"
#include "parser.h"

char *coloropen[] = {"r","g","b","c","m","y","k","w","undef"};


int main(void)
{
    RAWDATA *d;
    ENTITY *e;  /*the entities*/


    /*read the input in*/
    /*fprintf(stderr, "Reading...");*/
    d = reader();
    /*fprintf(stderr, " yay!\n");*/

    /*parse it*/
    /*fprintf(stderr, "Parsing...");*/
    e = parse(d->data,d->length);
    /*fprintf(stderr, " yay!\n");*/
    
    /*display the entities, one by one*/
    while(e->text)
    {
        printf("B=%d;EM=%d;I=%d;S=%d;TT=%d;U=%d;Sz=%d;C=%s;|%s|\n", e->bold, e->emph, e->italic, e->strong ,e->tt, e->underline, e->size,(e->color==-1)?"-1":coloropen[e->color],e->text);
        e++;
    }
    
    return 0;
}
