#!/usr/local/bin/perl -w

$numthings = shift;

@tags  = qw(B EM I PL S TT U 0 1 2 3 4 5 6 7 8 9 r g b c m y k w);
@words = qw(foo bar foobar moo cow blub bas blat blop squeak splat hmmm);

@tagstack = ();

open TEST, ">in" or die "cant create test data: $!";

for ($i = 0; $i < $numthings; ++$i) {
	$ran = int(rand 4);
	if ($ran == 0) {			# add tag
		$choice = int(rand (scalar @tags));
		$tag = $tags[$choice];
		print TEST "<$tag>";
		push @tagstack, ($tag);
	}
	elsif ($ran == 1 && (@tagstack != 0)) {		# close tag
		$tag = pop @tagstack;
		print TEST "</$tag>";
	}
	elsif ($ran == 2) {		# add words
		$choice = int(rand @words);
		print TEST $words[$choice];
	}
	else {					# add random spaces
		$numspace = int(rand 11);
		$spacechoice = int(rand 4);
		if ($spacechoice < 1) {
			$spacetype = " ";
		}
		elsif ($spacechoice < 2) {
			$spacetype = "\t";
		}
		elsif ($spacechoice < 3) {
			$spacetype = "\n";
		}
		else {
			$spacetype = "\r";
		}
		$spaces = $spacetype x $numspace;
		print TEST $spaces;
	}
}
while (@tagstack) {
	$tag = pop @tagstack;
	print TEST "</$tag>";
}
