#!/usr/local/bin/perl -w

open LOG, ">test.log" or die "cant open file: $!\n";

for $f (<testdata/*>) {
	$inputsize = (stat($f))[7];
	print "Test $f...";
	print LOG "Test $f...";
	`../optimise < $f > out`;
	`../showents < out > foo`;
	`../showents < $f > bar`;
	$wrong = system "diff foo bar";
	if ($wrong) {
		$incorrect = `./equiv.pl $f out`;
		if ($incorrect) {
			print "FAILED!\n";
			print LOG "FAILED!\n";
			rename "out", "errors/$f-err";
			next;
		}
	}
	$outputsize = (stat("out"))[7];
	$issmaller = ($inputsize >= $outputsize) ? "SMALLER!" : "BIGGER :(";
	print "OK! input: $inputsize --> output: $outputsize  $issmaller\n";
	print LOG "OK! input: $inputsize --> output: $outputsize  $issmaller\n";
}
print "Tests complete!\n";
print LOG "Tests complete!\n";

unlink 'out', 'foo', 'bar';
close LOG;
