/*
    parser.h
*/

typedef enum _color {RED=0, GREEN, BLUE, CYAN,
    MAGENTA, YELLOW, BLACK, WHITE, UNDEF_C, IRREL_C=-1} COLOR;


typedef struct _entity {
    char *text;                         /* NULL indicates end of data */
    char bold, emph, italic, strong, tt; /* either 0 or 1 */
    char underline;                      /* 0, 1, 2 or 3 */
    char size;                           /* 0 to 9, and 10 for undef */
    COLOR color;
} ENTITY;


ENTITY *parse(char *, int);
int attrcmp(ENTITY *, ENTITY *);
