#!/usr/local/bin/perl -w

$numcases  = shift;
$numthings = shift;
$err = 0;
$i = 0;

for ($i = 0; $i < $numcases; ++$i) {
	print "Test $i...";
	`./gentest.pl $numthings`;
	`../optimise < in > out`;
	`../showents < out > foo`;
	`../showents < in > bar`;
	$wrong = system "diff foo bar";
	if ($wrong) {
		$incorrect = system "./equiv.pl in out";
		if ($incorrect) {
			print "FAILED!\n";
			$err++;
			rename "in", "err$err-in";
			rename "out", "err$err-out";
			next;
		}
	}
	print "OK!\n";
}

unlink 'in', 'out', 'foo', 'bar';
